;; csound-scratch.el
;; unused code, for experimentation and development



(defun button-mask (beg end label action)
  "Note that the character after END will become inaccessible.
This works best when character after END is a whitespace"
    (let ((map (make-sparse-keymap))
	  (tov (make-overlay beg (1+ end))))
      (define-key map [mouse-2] 'button-unmask)
      (define-key map [mouse-3] 'button-unmask)
      (define-key map [mouse-1] action)
      (overlay-put tov 'mask t)
      (overlay-put tov 'display label)
      (overlay-put tov 'local-map map)

      (overlay-put tov 'field 'button)
      (overlay-put tov 'help-echo (lambda (w o p) (field-string-no-properties p)))

      (overlay-put tov 'priority 100)
      (overlay-put tov 'face 'custom-button)
      (overlay-put tov 'mouse-face 'custom-button-mouse)))

(defun button-unmask (event)
  (interactive "e")
  (save-excursion
    (mouse-set-point event)
    (let ((ov (find-if (lambda (ov)
			 (overlay-get ov 'mask))
		       (overlays-at (point)))))
      (delete-overlay ov))))

(defun button-edit (mode label event)
  (save-excursion
    (mouse-set-point event)
    (let* ((buff (or (buffer-base-buffer (current-buffer))
		     (current-buffer)))
	   (beg (field-beginning))
	   (ibuff (make-indirect-buffer 
		   buff 
		   (format "%s at L%s in %s" 
			   label (line-number-at-pos beg) buff)))
	   (end (- (field-end) 1)))
      (switch-to-buffer ibuff)
      (narrow-to-region beg end)
      (funcall mode))))

(defun button-python-edit (event)
  (interactive "e")
  (button-edit 'python-mode "python" event))

(defun button-lua-edit (event)
  (interactive "e")
  (button-edit 'lua-mode "lua code" event))

;beg
;(button-mask (point-at-bol) (point-at-eol) "sfj_'-" 'button-lua-edit) 
;(button-mask (point-at-bol) (point-at-eol) "sfj_'- (version 2.0)" 'button-python-edit)
;end

(defun cscsd-test-graphical-display ()
  (interactive)
    (let ((ibuff (make-indirect-buffer (current-buffer) "bouh")))
      (switch-to-buffer-other-frame ibuff)
      (button-mask (cscsd-orc-beginning) (cscsd-orc-end) " ORC ")
      (button-mask (cscsd-sco-beginning) (cscsd-sco-end) " SCO ")))


(defun cscsd-buttonize-python ()
  (interactive)
  (cscsd-buttonize-code-section "py.*" "python" 'button-python-edit))

(defun cscsd-buttonize-lua ()
  (interactive)
  (cscsd-buttonize-code-section "lua.*" "lua" 'button-lua-edit))

(defun cscsd-buttonize-code-section (regexp language action)
  (save-excursion
    (cscsd-goto-orc)
    (while (re-search-forward (concat "^[ \t]*" regexp "{{")
			      (cscsd-orc-end) t)
      (let ((beg (point))
	    (end (cond
		    ((re-search-forward
		      "^}}"
		      (cscsd-orc-end) t) (- (point) 3))
		    ((re-search-forward
		      "[\t ]}}"
		      (cscsd-orc-end) t) (- (point) 3))
		    ((re-search-forward
		      "}}"
		      (cscsd-orc-end)) (- (point) 2)))))
	(button-mask beg end
		     (concat " edit " language " code"
			     (if (= end (- (point) 2)) " }" " "))
		     action)))))

;; on revert buffer, unmask all !

